<?php
/**
 * Copyright (c) 2018.
 * Author: Igor Barkov <lopar.4ever@gmail.com>
 * Project name: Battles-Game
 */

ini_set('display_errors', 'On');
error_reporting(E_ALL);
define("GAMEDOMAIN","combats.loc");

/*
 * Запрещвем кэшировать
 */
header("Cache-Control: no-store, no-cache, must-revalidate, max-age=0");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

/**
 * Классы для работы с базой данных.
 */
require_once('Database/Mysql.php');
require_once('Database/Exception.php');
require_once('Database/Statement.php');
require_once('Database/db.php');

/**
 * Автозагрузка классов.
 */
spl_autoload_register(function ($class_name) {
    include_once 'classes/' . $class_name . '.php';
});
