<?php
session_start();
require_once 'functions.php';

$login = urldecode(filter_input(INPUT_SERVER, 'QUERY_STRING'));
$uid = isset($_SESSION['uid']) ? $_SESSION['uid'] : null;
$user = db::c()->query('SELECT `id`,`login`,`married`,`win`,borndate,`align`,`admin`,`realname`,`info`,`prof1`,`prof2`,`email`,`ip`,`exp`,`stats`,`money`,`room`,`doblest` 
                        FROM `users` 
                        WHERE `login` = "?s" OR `id` = "?s"', $login, $login)->fetch_assoc();
$own = db::c()->query('SELECT `align`,`admin` FROM `users` WHERE `id` = "?s"', $uid)->fetch_assoc();
$presents = db::c()->query('SELECT img, sender FROM `users_presents` WHERE expiration_date >= "?s" AND owner = ?i', date('Y-m-d'), $user['id']);

if (empty($user['id'])): ?>
    <html>
    <head>
        <meta charset="utf-8">
        <title>Ошибка</title>
    </head>
    <body style="color: #666; background-color: #d5d5d5; text-align: center; font-family: Consolas,monospace;">
    Ошибка: персонаж<?= ($login ? "&nbsp;<em>" . $login . "</em>" : ""); ?> не найден...
    <p><a style="color: #99f" href="javascript:window.history.go(-1);">←назад</a></p>
    </body>
    </html>
    <? exit(); endif; ?>

<html>
<head>
    <title>Информация о <?= $user['login'] ?></title>
    <meta charset=UTF-8"/>
    <link href="css/main.css" rel="stylesheet">
</head>
<BODY onload="<?= topsethp() ?>">
<?php if ($user['admin'] == 1 AND $own['admin'] != 1 AND file_exists('customuserdata/' . $user['id'])) die(file_get_contents('customuserdata/' . $user['id'])); ?>
<table width=100%>
    <tr>
        <td style="width: 250px; vertical-align: top;">
            <?= showinf_pers($user['id']);
            if (!empty($user['married'])): ?>
                <a href="inf.php?<?= $user['married'] ?>" target=_blank><img src="i/married.gif"
                                                                             title="В браке с <?= $user['married'] ?>"></a>";
            <?php endif; ?>
        </td>
        <td style="vertical-align: top; width: 100px; text-align: center;">
            <img src="i/zodiac/<?= star_sign(substr($user['borndate'], 3, 2), substr($user['borndate'], 0, 2)); ?>.png">
        </td>
    </tr>
</table>
<hr>
<!-- Нижняя часть -->
<?php
$effect = db::c()->query('SELECT `time` FROM `effects` WHERE `owner` = ?i AND `type` = ?i ', $user['id'], 5)->fetch_assoc();
if ($effect['time'] AND ($own['admin'] != 1)) die('<h3>Персонаж обезличен!</h3>');
if (!empty($user['realname'])) echo "Имя: " . $user['realname'] . "<br>";
?>
<p style="font-family: Consolas,monospace;"><?= nl2br($user['info']) ?></p>
<hr>
<?php if ($presents->getNumRows()): ?>
    <div>
        <legend>Подарки</legend>
        <?php
        while ($row = $presents->fetch_assoc()): ?>
            <img src="<?= $row['img'] ?>" title="<?= $row['sender'] ?>" alt="<?= $row['sender'] ?>">
        <?php endwhile; ?>
    </div>
<?php endif; ?>
<?php if (!empty($user['prof1']) OR !empty($user['prof2'])): ?>
    <div>
        <legend>Лицензии</legend>
        <?php
        if ($user['prof2'] == 21) echo ' <img src="i/prof21.png" title="Лицензия наемника"> ';
        if ($user['prof2'] == 22) echo ' <img src="i/prof22.png" title="Лицензия лекаря"> ';
        if ($user['prof1'] == 1) echo ' <img src="i/prof1.png" title="Лицензия кузнеца"> ';
        ?>
    </div>
<?php endif; ?>

<?php
# Секретный раздел
$showModeratorInfo = false;

# Если я любой паладин, и смотрю не админа, или я сам админ.
if ((($own['align'] == 1) AND (!$user['admin'])) OR (!empty($own['admin']))) $showModeratorInfo = true;

if ($showModeratorInfo == 1) {
    $ld = db::c()->query('SELECT * FROM `lichka` WHERE `pers` = ?i ORDER BY `id` ASC', $user['id']);
    $iplog = db::c()->query('SELECT idperslater FROM delo_multi WHERE idpersnow = ?i GROUP BY idperslater ASC', $user['id']);

    echo "<H4>Личное дело</H4>";
    while ($row_ld = $ld->fetch_assoc()) {
        $dat = date("d.m.Y H:i", $row_ld['date']);
        echo "<code>$dat {$row_ld['text']} </code><br />";
    }

    if ($iplog->getNumRows()) {
        echo "<H4>Возможные мульты</H4>";
        while ($row_iplog = $iplog->fetch_assoc()) echo nick::id($row_iplog['idperslater'])->full() . " ";
    }

    echo "<H4>Дополнительные сведения</H4>";
    if (!empty($user['id'])) echo "ID: " . $user['id'] . "<br>";
    if (!empty($user['email'])) echo "E-mail: " . $user['email'] . "<br>";
    if (!empty($user['borndate'])) echo "День рождения: " . $user['borndate'] . "<br>";
    if (!empty($user['ip'])) echo "IP при регистрации: " . $user['ip'] . "<br>";
}

if ($own['admin'] == 1) {
    if (!empty($user['exp'])) echo "Oпыт: " . $user['exp'] . "<br>";
    if (!empty($user['stats'])) echo "Число неиспользованных UP-ов: " . $user['stats'] . "<br>";
    if (!empty($user['money'])) echo "Кредитов: " . $user['money'] . "<br>";
    if (!empty($user['room'])) echo "Комната: " . $user['room'] . "<br>";
    if (!empty($user['reputation'])) echo "Всего Репутации: " . $user['reputation'] . "<br>";
    if (!empty($user['doblest'])) echo "Репутации: " . $user['doblest'] . "<br>";

    if ($user_bank = db::c()->query('SELECT `id`,`cr`,`ekr` FROM `bank` WHERE `id` = ?i', $user['id'])) {
        echo "<H4>Банковские счета</H4>";
        while ($row_user_bank = $user_bank->fetch_assoc())
            echo "№ " . $row_user_bank['id'] . ": " . $row_user_bank['cr'] . " кр, " . $row_user_bank['ekr'] . " екр.";
    }
}
?>

<script src="js/jquery-1.7.2.min.js"></script>
<script src="js/showthing.js"></script>
<script>
    $(function () {
        $(".tooltip").tipTip({maxWidth: "auto", edgeOffset: 0, fadeIn: 300, fadeOut: 500});
    });
</script>
</body>
</html>